<%@ page
	pageEncoding="UTF-8"
	session="false"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.Application"
	import="net.sf.basedb.clients.web.Base"	
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%
final SessionControl sc = Base.getExistingSessionControl(request, true);
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final String home = ExtensionsControl.getHomeUrl("net.sf.basedb.reggie");
DbControl dc = null;
try
{
	dc = sc.newDbControl();
	final User user = User.getById(dc, sc.getLoggedInUserId());
	%>
<base:page type="default" >
<base:head scripts="ajax.js" styles="path.css">
	<link rel="stylesheet" type="text/css" href="css/reggie.css">
	<script language="JavaScript" src="reggie.js" type="text/javascript" charset="UTF-8"></script>
		
		
	<script language="JavaScript">
	var currentStep = 1;
	var debug = false;
	var sitesCombined;
	var numCols;
	var unknownSite = 0;
	var unknownCreation;
	
	var month=new Array(12);
		month[0]="Jan";
		month[1]="Feb";
		month[2]="Mar";
		month[3]="Apr";
		month[4]="May";
		month[5]="Jun";
		month[6]="Jul";
		month[7]="Aug";
		month[8]="Sep";
		month[9]="Oct";
		month[10]="Nov";
		month[11]="Dec";
	
	var intervalIsValid = true;
	
	function goNext()
	{
		if (currentStep == 1)
		{
			gotoStep2();
		}
	}
	
	function gotoStep2()
	{
		var frm = document.forms['reggie'];
		frm.reporttype.disabled = true;
		if (frm.reporttype[frm.reporttype.selectedIndex].value == 'samplecount')
		{
			Main.show('sampleCountSection');
		}
				
		Main.show('gocreate');		
		Main.hide('gonext');
		frm.fromdate.focus();
		currentStep = 2;
	}
	
	function dateOnChange()
	{
		var frm = document.forms['reggie'];		
		var fdate;
		var tdate;
		
		intervalIsValid = false;
		setInputStatus('displayInterval','','valid');
		if (frm.fromdate.value != null && frm.fromdate.value != '')
		{
			frm.fromdate.value = autoFillDate(frm.fromdate.value);			
			if (!Dates.isDate(frm.fromdate.value, 'yyyyMMdd'))
			{
				setInputStatus('displayInterval','Not a valid from-date', 'invalid');
				return;
			}
			else
			{
				fdate = frm.fromdate.value;
				fdate = new Date(fdate.substr(0,4), parseInt(fdate.substr(4,2))-1, fdate.substr(6,2));
			}
		}
		
		if (frm.todate.value != null && frm.todate.value != '')
		{
			frm.todate.value = autoFillDate(frm.todate.value);
			if (!Dates.isDate(frm.todate.value, 'yyyyMMdd'))
			{
				setInputStatus('displayInterval', 'Not a valid to-date', 'invalid');
				return;
			}
			else
			{
				tdate = frm.todate.value;
				tdate = new Date(tdate.substr(0,4), parseInt(tdate.substr(4,2))-1, tdate.substr(6,2));
			}
		}
		
		if (tdate != null && fdate != null)
		{
			if (fdate > tdate)
			{
				setInputStatus('displayInterval', 'Invalid period', 'invalid')
				return;
			}			
		}
		intervalIsValid = true;
	}
	
	function goCreate()
	{
		if (!intervalIsValid) return;
		var cellElement = document.getElementById('reportcell');
		var frm = document.forms['reggie'];		
		frm.fromdate.disabled = true;
		frm.todate.disabled = true;
		Main.hide('gocreate');
		Main.show('reportSection');
		var reportType = frm.reporttype[frm.reporttype.selectedIndex].value;		
		var url = 'SampleReport.servlet?ID=<%=ID%>&cmd='+reportType;		
		
		if (reportType == 'samplecount')
		{			
			if (frm.fromdate.value != null) url += '&fdate='+frm.fromdate.value;
			if (frm.todate.value != null) url += '&tdate='+frm.todate.value;
		}
		var request = Ajax.getXmlHttpRequest();
		request.open("GET", url, false);
		request.send(null);
		
		if (debug) Main.debug(request.responseText);		
		var response = JSON.parse(request.responseText);	
		if (response.status != 'ok')
		{
			setFatalError(response.message);
			return false;
		}
		var report = response.report;
		var reportTable;
		
		if (report != null)
		{
			if ('samplecount' == reportType)
			{			
				reportTable = createSampleCountReport(report);
			}
		}
		else
		{
			var messageCell = getTableCellElement('No values could be found during given period', 'reportheader');
			var messageRow = document.createElement('tr');
			messageRow.appendChild(messageCell);			
			var messageTable = getReportTable();
			messageTable.appendChild(messageRow);
			reportTable = messageTable;			
		}
		setInnerHTML('reportcell', '');
		cellElement.appendChild(reportTable);
		var summaryList = document.createElement('ul');
		if (unknownSite == null) unknownSite = 0;
		if (unknownCreation == null) unknownCreation = 0;
		summaryList.appendChild(getListElement(unknownSite + ' specimens registered to unknown sites.'));
		summaryList.appendChild(getListElement(unknownCreation + ' specimens without creation date.'));
		cellElement.appendChild(summaryList);
		Main.show('gorestart');		
	}
	
	function createSampleCountReport(report)
	{
		var reportTable = getReportTable();
		var sdString = report.beginDate;
		var edString = report.endDate;
		var ldString = report.latestDate;
		var startDate = new Date();
		startDate.setYear(sdString.substr(0,4));
		startDate.setMonth(sdString.substr(4,2)-1);
		startDate.setDate(sdString.substr(6));
		var endDate = new Date();
		endDate.setYear(edString.substr(0,4));
		endDate.setMonth(edString.substr(4,2)-1);
		endDate.setDate(edString.substr(6));
		var latestDate;
		if (ldString != null)
		{
			latestDate = new Date();
			latestDate.setYear(ldString.substr(0,4));
			latestDate.setMonth(ldString.substr(4,2)-1);
			latestDate.setDate(ldString.substr(6));
		}		
		
		var viewType = report.viewType;		
	
		var headerRow = document.createElement('tr');		
		var subHeaderRowYear = document.createElement('tr');
		var columnHeaderRow = document.createElement('tr');
		
		var headerText = '# Specimen by ';
		if (viewType == 'WEEK')
		{	
			var startWeek = getWeekByDate(startDate);
			var endWeek = getWeekByDate(endDate);
			var tempDate = new Date(startDate.getFullYear(), startDate.getMonth(), startDate.getDate()-startDate.getDay()+1);
			numCols = 0;
			while (tempDate < endDate)
			{
				numCols++;
				tempDate.setDate(tempDate.getDate()+7);
			}
			headerText += 'week';
		}
		else if (viewType == 'MONTH')
		{
			numCols = (endDate.getFullYear()-startDate.getFullYear())*12 + endDate.getMonth()-startDate.getMonth()+1;
			headerText += 'month';
		}
		else if (viewType == 'QUARTER')
		{
			//First year
			numCols = 4 - Math.floor(startDate.getMonth()/3);
			numCols += Math.floor(endDate.getMonth()/3)+1;
			if((endDate.getFullYear() - startDate.getFullYear()) > 1) numCols += 4 * (endDate.getFullYear() - startDate.getFullYear()-1);
			headerText += 'quarter';
		}
		else
		{
			numCols = endDate.getFullYear() - startDate.getFullYear() + 1;
			headerText += 'year';
		}
		sitesCombined = Array(numCols);
			
		// Set table header
		headerText += ' (between ' + startDate.getFullYear()+'-';
		if ((startDate.getMonth()+1) < 10) headerText += '0' + (startDate.getMonth()+1);
		else headerText += (startDate.getMonth()+1);
		headerText += '-';
		if (startDate.getDate() < 10) headerText += '0' + startDate.getDate();
		else headerText += startDate.getDate();
		headerText += ' and ';
		headerText += endDate.getFullYear()+'-';
		if ((endDate.getMonth()+1) < 10) headerText += '0' + (endDate.getMonth()+1);
		else headerText += (endDate.getMonth()+1);
		headerText += '-';
		if (endDate.getDate() < 10) headerText += '0' + endDate.getDate();
		else headerText += endDate.getDate();
		headerText += ')';
		if (latestDate != null)
		{
			headerText += '\nLast registration ' + latestDate.getFullYear();
			headerText += '-';
			if ((latestDate.getMonth()+1) < 10) headerText += '0';
			headerText += (latestDate.getMonth()+1);
			headerText += '-';
			if (latestDate.getDate()<10) headerText += '0';
			headerText += latestDate.getDate();
		}		
		headerRow.appendChild(getTableCellElement(headerText, 'reportheader', (numCols+3)));
		
		// Sub headers
		// Only if each datacol is less then a year
		if (viewType != 'YEAR')
		{
			subHeaderRowYear.appendChild(getTableCellElement('', 'reportsubheader', 2));
			addYearSubHeaders(startDate, endDate, subHeaderRowYear, viewType);			
			subHeaderRowYear.appendChild(getTableCellElement('', 'reportsubheader'));
		}		
					
		// Columnsheader		
		var siteHeader = getTableCellElement('Site', 'reportsubheader');			
		var startDateHeader = getTableCellElement('Start date','reportsubheader');
		columnHeaderRow.appendChild(siteHeader);
		columnHeaderRow.appendChild(startDateHeader);	
		
		if (viewType == 'MONTH') addMonthColumnHeaders(columnHeaderRow, startDate);
		else if (viewType == 'WEEK') addWeekColumnHeaders(columnHeaderRow, startDate);
		else if (viewType == 'QUARTER') addQuarterColumnHeaders(columnHeaderRow, startDate);
		else if (viewType == 'YEAR') addYearSubHeaders(startDate, endDate, columnHeaderRow, viewType);
		
		
		columnHeaderRow.appendChild(getTableCellElement('Grand\ntotal', 'reportsubheader'));

		// Build table			
		reportTable.appendChild(headerRow);
		reportTable.appendChild(subHeaderRowYear);
		reportTable.appendChild(columnHeaderRow);
					
		// Data rows			
		addDataRowsToTable(report, reportTable);
			
		// Add a row with the combined number of each month-column
		var sitesCombinedRow = document.createElement('tr');
		sitesCombinedRow.appendChild(getTableCellElement('Sites combined', 'colsummary'));
		sitesCombinedRow.appendChild(getTableCellElement('', 'colsummary'));
		var gt = 0;
		for (key in sitesCombined)
		{
			sitesCombinedRow.appendChild(getTableCellElement(sitesCombined[key],'colsummary'));
			if (sitesCombined[key] != '') gt += sitesCombined[key];
		}
		sitesCombinedRow.appendChild(getTableCellElement(gt, 'colsummary'));
		reportTable.appendChild(sitesCombinedRow);	
		return reportTable;
	}
	
	function addQuarterColumnHeaders(columnHeaderRow, startDate)
	{
		var currentDate = startDate;
		for (var i=0;i<numCols;i++)
		{
			var quarter = Math.floor(currentDate.getMonth()/3)+1;
			var columnText = 'Q'+quarter;
			var quarterHeader = getTableCellElement(columnText, 'reportsubheader');
			columnHeaderRow.appendChild(quarterHeader);	
			currentDate.setMonth(currentDate.getMonth()+3);			
		}
	}
	
	function addWeekColumnHeaders(columnHeaderRow, startDate)
	{
		var currentDate = startDate;
		var day = currentDate.getDay()-1;
		day = day>=0 ? day: day + 7;
		currentDate.setDate(currentDate.getDate()-day);
		for (var i=0;i<numCols;i++)
		{			
			var weekNum = getWeekByDate(currentDate);
			var columnText = weekNum;
			if (weekNum < 10) columnText = '0'+columnText;			
			columnHeaderRow.appendChild(getTableCellElement(columnText, 'reportsubheader'));
			currentDate.setDate(currentDate.getDate()+7);			
		}
	}
	
	function addMonthColumnHeaders(columnHeaderRow, startDate)
	{		
		var currentDate = new Date(startDate.getFullYear(), startDate.getMonth());
		for (var i=0;i<numCols;i++)
		{							
			var monthHeader = getTableCellElement(month[currentDate.getMonth()], 'reportsubheader');
			columnHeaderRow.appendChild(monthHeader);				
			currentDate.setMonth(currentDate.getMonth() +1);
		}		
	}
	
	function addYearSubHeaders(startDate, endDate, subHeaderRowYear, vt)
	{		
		var currentYear = startDate.getFullYear();	
		
		var columnCounter = 0;		
		do
		{
			var colspan;
			var headerText = currentYear;
			if (vt == "MONTH")
			{
				if (currentYear == startDate.getFullYear())
				{
					colspan =  11-parseInt(startDate.getMonth())+1;
					if (endDate.getFullYear() == currentYear)
					{
						colspan = colspan - (11-parseInt(endDate.getMonth()));
					}
				}
				else if (currentYear == endDate.getFullYear()) 
					colspan = parseInt(endDate.getMonth()+1);
				else
					colspan = 12;
			}
			else if (vt == "WEEK")
			{	
				if (startDate.getFullYear() == endDate.getFullYear())
				{
					colspan = numCols;
				}
				else if (currentYear == startDate.getFullYear())
				{
					var startWeek = getWeekByDate(startDate);
					var lastDay = new Date(startDate.getFullYear(), 11, 31);
					var endWeek = getWeekByDate(lastDay);
					if (endWeek == 1) endWeek = getWeekByDate(lastDay.setDate(lastDay.getDate()-7));
					colspan = endWeek - startWeek +1;
				}
				else if (currentYear == endDate.getFullYear())
				{
					var endWeek = getWeekByDate(endDate);
					colspan = endWeek;
				}
				else
				{
					var dateInLastWeek = new Date(currentYear, 11, 31);
					var endWeek = getWeekByDate(dateInLastWeek);
					if (endWeek == 1) endWeek = getWeekByDate(dateInLastWeek.setDate(dateInLastWeek.getDate()-7));
					colspan = endWeek;
				}								
			}
			else if (vt == "QUARTER")
			{
				if (currentYear == startDate.getFullYear())
				{
					if (startDate.getFullYear() == endDate.getFullYear())
					{
						colspan = Math.floor((endDate.getMonth()-startDate.getMonth())/3)+1;
					}
					else
					{
						colspan = Math.floor((11-startDate.getMonth())/3) +1;
					}
				}
				else if(currentYear == endDate.getFullYear())
				{
					colspan = Math.floor(endDate.getMonth()/3)+1;
				}
				else 
				{
					colspan = 4;
				}
			}
			else if (vt == "YEAR")
			{
				colspan = 1;				
			}
			columnCounter += colspan;						
			subHeaderRowYear.appendChild(getTableCellElement(headerText, 'reportsubheader', colspan));
		}while(!(++currentYear>endDate.getFullYear()));
	}
	
	function addDataRowsToTable(report, reportTable)
	{
		var fdString = report.beginDate;
		var ldString = report.endDate;
		var startDate = new Date();
		startDate.setYear(fdString.substr(0,4));
		startDate.setMonth(fdString.substr(4,2)-1);
		startDate.setDate(fdString.substr(6));
		var endDate = new Date();
		endDate.setYear(ldString.substr(0,4));
		endDate.setMonth(ldString.substr(4,2)-1);
		endDate.setDate(ldString.substr(6));
		var viewType = report.viewType;		
		var sites = report.sites;		
		var statistics = report.statistics;
		unknownCreation = statistics.noDate;
		unknownSite = statistics.unknownSite;
		for (namePrefix in sites)
		{
			if (!sites.hasOwnProperty(namePrefix)) continue;				
			var site = sites[namePrefix];
			var siteName = site.name;				
			var year = site.startDate.substr(0,4);
			var month = site.startDate.substr(5,2);
			var date = site.startDate.substr(8,2);			
			var siteStartDate = new Date(year, month-1, date);
			
			var siteData = statistics[namePrefix];			
			var tableRow = document.createElement('tr');
			var tableCol = getTableCellElement(siteName, 'rowtitle');
			tableRow.appendChild(tableCol);
			tableRow.appendChild(getTableCellElement(year+'-'+(month)+'-'+date, 'reportdata'));
			var currentDate = new Date(startDate.getFullYear(), startDate.getMonth(), startDate.getDate());			
			var grandTotal = 0;
			var columnCounter = 0;
			do
			{	
				var data = 0;
				var keyIndex;
				var yearIndex = currentDate.getFullYear();
				
				if (viewType == 'YEAR')
				{
					keyIndex = yearIndex;
					if (siteData != null)
					{
						if (siteData[keyIndex] != null) data = siteData[keyIndex];
					}
					grandTotal += data;					
					if ( (currentDate.getFullYear() <= siteStartDate.getFullYear()))
					{
						data = '';
						if (sitesCombined[keyIndex] == null) sitesCombined[keyIndex] = data;
					}
					else if (sitesCombined[keyIndex] == null || sitesCombined[keyIndex] == '') sitesCombined[keyIndex] = data;
					else sitesCombined[keyIndex] += data;
					currentDate.setFullYear(currentDate.getFullYear()+1);
				}
				else if (viewType == 'QUARTER')
				{
					var qIndex = Math.floor(currentDate.getMonth()/3) + 1;
					var startQuarter = Math.floor(siteStartDate.getMonth()/3)+1;
					keyIndex = yearIndex + '' + qIndex;
					if (siteData != null)
					{
						if (siteData[keyIndex] != null) data = siteData[keyIndex];						
					}					
					grandTotal += data;
					if ( (currentDate.getFullYear() <= siteStartDate.getFullYear()) && qIndex<startQuarter)
					{
						data = '';
						if (sitesCombined[keyIndex] == null) sitesCombined[keyIndex] = data;
					}
					else if (sitesCombined[keyIndex] == null || sitesCombined[keyIndex] == '') sitesCombined[keyIndex] = data;
					else sitesCombined[keyIndex] += data;
					currentDate.setMonth(currentDate.getMonth()+3);					
				}
				else if (viewType == 'MONTH')
				{
					var monthIndex = currentDate.getMonth()+1;
					var rowFill = monthIndex < 10 ? '0' : '';
					keyIndex = yearIndex + rowFill + monthIndex;
					if (siteData != null)
					{
						if (siteData[keyIndex] != null) data = siteData[keyIndex];
					}
					grandTotal += data;					
					if (currentDate.getFullYear() <= siteStartDate.getFullYear() && (monthIndex-1) < siteStartDate.getMonth())
					{
						data = '';
						if (sitesCombined[keyIndex] == null) sitesCombined[keyIndex] = data;
					}
					else if (sitesCombined[keyIndex] == null || sitesCombined[keyIndex] == '') sitesCombined[keyIndex] = data;
					else sitesCombined[keyIndex] += data;
					
					
					currentDate.setMonth(currentDate.getMonth()+1);
				}
				else if (viewType == 'WEEK')
				{
					var weekIndex = getWeekByDate(currentDate);
					keyIndex = yearIndex + '' + weekIndex;
					if (siteData != null)
					{
						if (siteData[keyIndex] != null) data = siteData[keyIndex];
					}
					grandTotal += data;					
					if (currentDate.getFullYear() <= siteStartDate.getFullYear() && getWeekByDate(currentDate) < getWeekByDate(siteStartDate))
					{
						data = '';
						if (sitesCombined[keyIndex] == null) sitesCombined[keyIndex] = data;
					}
					else if (sitesCombined[keyIndex] == null || sitesCombined[keyIndex] == '') sitesCombined[keyIndex] = data;
					else sitesCombined[keyIndex] += data;
					currentDate.setDate(currentDate.getDate()+7);
				}
				
				tableRow.appendChild(getTableCellElement(data, 'reportdata'));
				columnCounter++;				
			}while (columnCounter< numCols)			
			tableRow.appendChild(getTableCellElement(parseInt(grandTotal), 'rowsummary'));
			reportTable.appendChild(tableRow);
		}
	}
	
	function getReportTable()
	{
			var reportTable = document.createElement('table');
			reportTable.setAttribute('class','reporttable');
			reportTable.setAttribute('border','1');			
			return reportTable;
	}
	
	function getTableCellElement(text, clazz, colspan, rowspan)
	{
		var cellElement = document.createElement('td');
		text = new String(text);		
		var textArray = text.split("\n");		
		if (textArray.length > 1)
		{	
			for (var i=0;i<textArray.length;i++)
			{				
				if (i>0)cellElement.appendChild(document.createElement('br'));
				cellElement.appendChild(document.createTextNode(textArray[i]));
			}			
		}
		else
		{
			cellElement.appendChild(document.createTextNode(text));
		}
		cellElement.setAttribute('class', clazz);
		if (colspan != null) cellElement.setAttribute('colspan', colspan);
		if (rowspan != null) cellElement.setAttribute('rowspan', rowspan);
		
		return cellElement;
	}
	
	function getListElement(itemText)
	{
		var listElement = document.createElement('li');
		var textNode = document.createTextNode(itemText);
		listElement.appendChild(textNode);
		return listElement;
	}
	</script>
	
	
	</base:head>
	<base:body onload="init()">
		<p:path><p:pathelement 
			title="Reggie" href="<%="index.jsp?ID="+ID%>" 
			/><p:pathelement title="Report generator" 
			/></p:path>
		<div class="content">
		<%
		if (sc.getActiveProjectId() == 0)
		{
			%>
			<div class="messagecontainer note" style="width: 950px; margin-left: 20px; margin-bottom: 20px; margin-right: 0px; font-weight: bold; color: #cc0000;">
				No project has been selected. You may proceed with the report generation but 
				only your own items will be included in the report.
			</div>
			<%
		}
		%>
	
		<form name="reggie" onsubmit="return false;">
			<!-- 1. Report type-->
			<table border="0" cellspacing="0" cellpadding="0" class="stepform">
			<tr>
				<td rowspan="3" class="stepno">1</td>
				<td class="steptitle">Report type</td>
			</tr>
			<tr>
				<td class="stepfields">
					<table border="0" cellspacing="0" cellpadding="0" width="100%">
					<tr valign="top">
						<td class="prompt">Report</td>
						<td class="input">
							<select name="reporttype">
								<option value="samplecount">Sample count report</option>
							</select>
						</td>
						<td class="status" id="report.status"></td>
						<td class="help">
							<span id="report.message" class="message" style="display: none;"></span>
							Select which report to generate.
						</td>
					</tr>
					</table>
				</td>
			</tr>
			</table>
			
			<div id="sampleCountSection" style="display:none;">
				<p></p>
				<!-- 2. Report parameters-->
				<table border="0" cellspacing="0" cellpadding="0" class="stepform">
				<tr>
					<td rowspan="3" class="stepno">2</td>
					<td class="steptitle">Report parameters</td>
				</tr>
				<tr>
					<td class="stepfields">
						<table border="0" cellspacing="0" cellpadding="0" width="100%">						
						<tr>
							<td valign="top" class="prompt">Report period</td>
							<td valign="top" class="input">
								From<input type="text" onChange="dateOnChange()" size=7 name="fromdate"/>&nbsp;
								To<input type="text" onChange="dateOnChange()" size=7 name="todate" />
							</td>
							<td valign="top" class="status" id="displayInterval.status"></td>
							<td class="help">
								<span id="displayInterval.message" class="message" style="display: none;"></span>
								Define which period the report should cover. Empty fields will include all tubes.<br>
								The report will adjust itself depending on the size of the period.
								<ul>
									<li>Period shorter then 3 months - specimens per week</li>
									<li>Period shorter then 13 months - specimens per month</li>
									<li>Period shorter then 3 year - specimens per quarter</li>
									<li>Period is 3 year or greater - specimens per year</li>
								</ul> 								
							</td>
						</tr>						
						</table>
					</td>
				</tr>
				</table>
			</div>
			
			<div id="reportSection" style="display:none;">
				<p></p>
				<table border="0" cellspacing="0" cellpadding="0" class="stepform">
				<tr>
					<td rowspan="3" class="stepno">3</td>
					<td class="steptitle">Generated report</td>
				</tr>
				<tr>
					<td id="reportcell" class="stepfields">
						<i>Generating report...</i>
					</td>
				</tr>
				</table>
			</div>	
			
			<div class="messagecontainer error" id="errorMessage" style="display: none; width: 950px; margin-left: 20px; margin-bottom: 0px;"></div>		
				
			<table style="margin-left: 20px; margin-top: 10px;" class="navigation">
				<tr>
					<td><base:button id="gocancel" title="Cancel" onclick="goRestart(false)" style="display: none;"/></td>
					<td><base:button id="gonext" title="Next" image="<%=home+"/images/gonext.png"%>" onclick="goNext(true)" /></td>
					<td><base:button id="gocreate" title="Generate" image="<%=home+"/images/gonext.png"%>" onclick="goCreate()" style="display: none;"/></td>					
					<td><base:button id="gorestart" title="Restart" image="<%=home+"/images/goback.png"%>" onclick="goRestart(true)" style="display: none;"/></td>
					<td id="gonext.message" class="message"></td>
				</tr>
			</table>			
		</form>
		</div>
		
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>